#include <bits/stdc++.h>

using namespace std;
long long p[75010];
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    bool b=1;
    int t,n,m;
    long long a,x;
    cin>>t;
    for(int j=0;j<t;j++){
        cin>>n>>m;
        for(int i=0;i<n;i++)
            cin>>p[i];
        sort(p,p+n);
        x=p[1]-p[0];
        for(int i=2;i<n;i++){
            x=__gcd(x,p[i]-p[i-1]);
        }
        for(int i=0;i<m;i++){
            cin>>a;
            if(abs(a-p[0])%x==0)
                b=0;
        }
        if(b)
            cout<<"1\n";
        else
            cout<<"0\n";
    }
    return 0;
}